#!/usr/bin/python

import sys
import random
import time

# maximum time in seconds for one turn of one player
MAXRUNTIME = 1

EMPTY = 0
ENEMY = 1
OWN   = 2

REMI = 0
WIN = 1
NONE = 2

# Diese Klasse Implementiert die KI fuer 4Gewinnt
# Benennen Sie Ihre Version in VierGewinntMeinname um
class VierGewinntDummy(object):
    def __init__(self, size):
        self.n = size[0] # Anzahl Spalten
        self.m = size[1] # Anzahl Zeilen
        self.field = [] # Initialisierung des Spielfeldes
        for i in range(0,self.n):
            self.field.append(self.m*[EMPTY])
        self.heightcol = self.n*[0]
        self.freecols = self.n
        random.seed() # die Dumme KI legt die Steine auf zufaellige gueltige Plaetze
        
    # ueberprueft ob das Spiel gewonnen wurde, ob ein Remi eingetreten ist oder ob weitergespielt werden muss
    # sie koennen diese Routine verwenden oder durch eine effizientere Version ersetzen
    def checkWin(self, col):
        if self.freecols == 0:
            return REMI
        lineorient = [[1, 0], [0, 1], [1,1], [1, -1]]
        for o in range(0,len(lineorient)):
            length = 0
            i = col
            j = self.heightcol[i]-1
            while i < self.n and i >= 0 and j < self.m and j >= 0 and self.field[i][j] == OWN:
                length += 1
                i += lineorient[o][0]
                j += lineorient[o][1]
            i = col
            j = self.heightcol[i]-1
            length -= 1
            while i < self.n and i >= 0 and j < self.m and j >= 0 and self.field[i][j] == OWN:
                length += 1
                i -= lineorient[o][0]
                j -= lineorient[o][1]
            if length > 3:
                return WIN
        return NONE
        
    # setzt einen Stein in die i-te Spalte
    # sie koennen diese Routine verwenden oder durch eine effizientere Version ersetzen
    def setStone(self,i,type):
        if self.heightcol[i] == self.m:
            print 'INVALID TURN FROM ENEMY'
            return None
        self.field[i][self.heightcol[i]] = type
        self.heightcol[i] += 1
        if self.heightcol[i] == self.m:
            self.freecols -= 1
        if type == OWN:
            return [ i, self.heightcol[i]-1, self.checkWin(i)]
    
    # INPUT:  den letzen Zug des Gegners
    # OUTPUT: eigener Zug
    # Diese Routine muessen Sie durch Ihre Version ersetzen
    # lediglich den Prozedurkopf duerfen sie nicht aendern
    def step(self,i):
        if i >= 0: # not first turn in game
            self.setStone(i,ENEMY)
        rnd = random.randint(0,self.freecols-1)
        rndc = rnd
        while rndc < self.n-1 and self.heightcol[rndc] == self.m:
            rndc += 1
        if self.heightcol[rndc] < self.m:
            return self.setStone(rndc,OWN)
        else:
            rndc = rnd-1
            while rndc > 0 and self.heightcol[rndc] == self.m:
                rndc -= 1
            if self.heightcol[rndc] < self.m:
                return self.setStone(rnd,OWN)
          
# gibt das momentane Spielfeld aus
def printField(a):
    for j in range(len(a[0])-1,-1,-1):
        print '|',
        for i in range(0,len(a)):
            if a[i][j] == 0:
                print ' ',
            elif a[i][j] == 1:
                print 'X',
            else:
                print 'O',
        print '|\n',
    for i in range(0,len(a)+2):
        print '-',
    print '\n',
   
   
# ====================================   
# Code zur Steuerung und Ausgabe des Spielablaufs
# ====================================
gamefieldsize = [7,6]  # groesse des Spielfeldes
player1 = VierGewinntDummy(gamefieldsize) # durch die Klasse des Spielers 1 ersetzen z.B. VierGewinntStudent1()
player2 = VierGewinntDummy(gamefieldsize) # durch die Klasse des Spielers 2 ersetzen z.B. VierGewinntStudent2()
ret = [-1, -1, NONE]
p = 0
fieldctl = []
for i in range(0,gamefieldsize[0]):
    fieldctl.append(gamefieldsize[1]*[0])

# Das Spiel beginnt
print 'gamefield',gamefieldsize[0],'x',gamefieldsize[1],'\n[X] Player 1\n[O] Player 2\n',
while ret[2] == NONE:
    p = 1
    start = time.clock()
    ret = player1.step(ret[0])
    if time.clock()-start > MAXRUNTIME:
        print 'TIME LIMIT EXCEEDED! Player 1 Lost!'
        sys.exit(0)
    fieldctl[ret[0]][ret[1]] = p
    printField(fieldctl)
    if ret[2] != NONE:
        break
    p = 2
    start = time.clock()
    ret = player2.step(ret[0])
    if time.clock()-start > MAXRUNTIME:
        print 'TIME LIMIT EXCEEDED! Player 2 Lost!'
        sys.exit(0)
    fieldctl[ret[0]][ret[1]] = p
    printField(fieldctl)
    
if ret[2] == REMI:
    print 'REMI'
else:
    print 'Player',p,'WON!'
